local _G = GLOBAL
local TUNING = _G.TUNING

local ROG = GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS)
local CSW = GLOBAL.rawget(GLOBAL, "CAPY_DLC") and GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC)

-- Style
TUNING.OWN_HEAD = GetModConfigData("head")
TUNING.OWN_HAIR = GetModConfigData("hairpigtails")
TUNING.OWN_HAIR2 = GetModConfigData("hair")
TUNING.OWN_FACE = GetModConfigData("face")
TUNING.OWN_CHEEKS = GetModConfigData("cheeks")
TUNING.OWN_TORSO = GetModConfigData("torso")
TUNING.OWN_TORSO_PELVIS = GetModConfigData("torso_pelvis")
TUNING.OWN_ARM_UP = GetModConfigData("arm_upper")
TUNING.OWN_ARM_LOW = GetModConfigData("arm_lower")
TUNING.OWN_HANDS = GetModConfigData("hand")
TUNING.OWN_SKIRT = GetModConfigData("skirt")
TUNING.OWN_LEGS = GetModConfigData("leg")
TUNING.OWN_FOOTS = GetModConfigData("foot")
TUNING.OWN_AVATAR = GetModConfigData("avatar")
TUNING.OWN_MAP = GetModConfigData("mini-map")
TUNING.OWN_BIGPORT = GetModConfigData("bigportraits")

-- Stats
TUNING.OWN_HP = GetModConfigData("own_hp")
TUNING.OWN_HUNGER = GetModConfigData("own_hunger")
TUNING.OWN_SANITY = GetModConfigData("own_sanity")
TUNING.OWN_GENDER = GetModConfigData("own_gender")
TUNING.OWN_TALK_SOUND = GetModConfigData("soundname")

-- Perks
TUNING.OWN_PERK1 = GetModConfigData("perk1")
TUNING.OWN_PERK2 = GetModConfigData("perk2")

-- Inventory
TUNING.OWN_ITEM1 = GetModConfigData("start_item1")
TUNING.OWN_ITEM2 = GetModConfigData("start_item2")
TUNING.OWN_ITEM3 = GetModConfigData("start_item3")

PrefabFiles = {
	"my_own",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/my_own.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/my_own.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/my_own.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/my_own.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/my_own_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/my_own_silho.xml" ),

    Asset( "IMAGE", "bigportraits/my_own.tex" ),
    Asset( "ATLAS", "bigportraits/my_own.xml" ),
	
	Asset( "IMAGE", "images/map_icons/my_own.tex" ),
	Asset( "ATLAS", "images/map_icons/my_own.xml" ),
	
	Asset( "ANIM", "anim/corner_dude.zip" ),
	
	Asset( "ANIM", "anim/wilson.zip" ),
	Asset( "ANIM", "anim/willow.zip" ),
	Asset( "ANIM", "anim/wolfgang.zip" ),
	Asset( "ANIM", "anim/wendy.zip" ),
	Asset( "ANIM", "anim/wx78.zip" ),
	Asset( "ANIM", "anim/wickerbottom.zip" ),
	Asset( "ANIM", "anim/woodie.zip" ),
	Asset( "ANIM", "anim/wes.zip" ),
	Asset( "ANIM", "anim/waxwell.zip" ),
	
	Asset( "ANIM", "anim/player_idles.zip" ),
	Asset( "ANIM", "anim/own_menu.zip" ),
	
	Asset("ANIM", "anim/lucy_axe.zip"),
    Asset("ANIM", "anim/swap_lucy_axe.zip"),
    Asset("MINIMAP_IMAGE", "lucy_axe"),
	Asset("ANIM", "anim/balloons_empty.zip"),
	Asset("ANIM", "anim/book_maxwell.zip"),
	
	--Shadow max
    Asset("ANIM", "anim/waxwell_shadow_mod.zip"),
	Asset("SOUND", "sound/maxwell.fsb"),
	Asset("ANIM", "anim/swap_pickaxe.zip"),
	Asset("ANIM", "anim/swap_axe.zip"),
	Asset("ANIM", "anim/swap_nightmaresword.zip"),
	Asset("ANIM", "anim/rowboat_basic.zip"),
	Asset("ANIM", "anim/waxwell_shadowboat_build.zip"),
	--
}

local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS

-- The character select screen lines
STRINGS.CHARACTER_TITLES.my_own = "My Own Character"
STRINGS.CHARACTER_NAMES.my_own = "Own Character"
STRINGS.CHARACTER_DESCRIPTIONS.my_own = "Set perks on config"
STRINGS.CHARACTER_QUOTES.my_own = "\"My Own Character\""

STRINGS.CHARACTERS.my_own = require "speech_my_own"

if ROG then
	table.insert(Assets, Asset( "ANIM", "anim/webber.zip" ))
	table.insert(Assets, Asset( "SOUND", "sound/webber.fsb"))
    table.insert(Assets, Asset( "ANIM", "anim/wathgrithr.zip" ))
	table.insert(Assets, Asset( "ANIM", "anim/swap_spear_wathgrithr.zip" ))
	table.insert(Assets, Asset( "ANIM", "anim/spear_wathgrithr.zip" ))
	table.insert(Assets, Asset( "SOUND", "sound/wathgrithr.fsb"))
end

if CSW then
	table.insert(Assets, Asset( "ANIM", "anim/walani.zip" ))
    table.insert(Assets, Asset( "ANIM", "anim/warly.zip" ))
	table.insert(Assets, Asset( "ANIM", "anim/wilbur.zip" ))
	table.insert(Assets, Asset( "ANIM", "anim/woodlegs.zip" ))
	table.insert(Assets, Asset( "ANIM", "anim/wilbur_run.zip" ))
	
	table.insert(Assets, Asset( "ANIM", "anim/cook_pot_warly.zip" ))
	table.insert(Assets, Asset( "ANIM", "anim/cook_pot_food.zip" ))
	table.insert(Assets, Asset( "MINIMAP_IMAGE", "cookpotwarly" ))
end

if TUNING.OWN_GENDER == "male" then
    table.insert(GLOBAL.CHARACTER_GENDERS.MALE, "my_own")
end

if TUNING.OWN_GENDER == "famale" then
    table.insert(GLOBAL.CHARACTER_GENDERS.FEMALE, "my_own")
end

AddMinimapAtlas("images/map_icons/my_own.xml")
AddModCharacter("my_own")

local random_char = {
    "wilson",
	"willow",
	"wolfgang",
	"wendy",
	"wx78",
	"wickerbottom",
	"woodie",
	"wes",
	"waxwell",
	"webber",
	--"wathgrithr",
}

local function Press_Random()
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("headbase", random_char[math.random(#random_char)], "headbase")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("headbase_hat", random_char[math.random(#random_char)], "headbase_hat")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("hair", random_char[math.random(#random_char)], "hair")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("hair_hat", random_char[math.random(#random_char)], "hair_hat")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("hairpigtails", random_char[math.random(#random_char)], "hairpigtails")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("face", random_char[math.random(#random_char)], "face")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("cheeks", random_char[math.random(#random_char)], "cheeks")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("torso", random_char[math.random(#random_char)], "torso")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("torso_pelvis", random_char[math.random(#random_char)], "torso_pelvis")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("arm_upper", random_char[math.random(#random_char)], "arm_upper")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("arm_lower", random_char[math.random(#random_char)], "arm_lower")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("hand", random_char[math.random(#random_char)], "hand")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("skirt", random_char[math.random(#random_char)], "skirt")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("leg", random_char[math.random(#random_char)], "leg")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("foot", random_char[math.random(#random_char)], "foot")
end

local function Press_Random2()
    local head_random = "wilson"
	head_random = random_char[math.random(#random_char)]
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("headbase", head_random, "headbase")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("headbase_hat", head_random, "headbase_hat")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("hair", head_random, "hair")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("hair_hat", head_random, "hair_hat")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("hairpigtails", random_char[math.random(#random_char)], "hairpigtails")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("face", random_char[math.random(#random_char)], "face")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("cheeks", random_char[math.random(#random_char)], "cheeks")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("torso", random_char[math.random(#random_char)], "torso")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("torso_pelvis", random_char[math.random(#random_char)], "torso_pelvis")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("arm_upper", random_char[math.random(#random_char)], "arm_upper")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("arm_lower", random_char[math.random(#random_char)], "arm_lower")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("hand", random_char[math.random(#random_char)], "hand")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("skirt", random_char[math.random(#random_char)], "skirt")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("leg", random_char[math.random(#random_char)], "leg")
	GLOBAL.GetPlayer().AnimState:OverrideSymbol("foot", random_char[math.random(#random_char)], "foot")
end

modimport("own_custom.lua")

-- Load cusom setings form own_custom.lua if need.
if own_custom_only_custom == "false" then
if GetModConfigData("head") == "custom" then
    TUNING.OWN_HEAD = own_custom_head
end
if GetModConfigData("hairpigtails") == "custom" then
    TUNING.OWN_HAIR = own_custom_hair
end
if GetModConfigData("hair") == "custom" then
    TUNING.OWN_HAIR2 = own_custom_hair2
end
if GetModConfigData("face") == "custom" then
    TUNING.OWN_FACE = own_custom_face
end
if GetModConfigData("cheeks") == "custom" then
    TUNING.OWN_CHEEKS = own_custom_cheers
end
if GetModConfigData("torso") == "custom" then
    TUNING.OWN_TORSO = own_custom_torso
end
if GetModConfigData("arm_upper") == "custom" then
    TUNING.OWN_ARM_UP = own_custom_arm_up
end
if GetModConfigData("arm_lower") == "custom" then
    TUNING.OWN_ARM_LOW = own_custom_arm_low
end
if GetModConfigData("hand") == "custom" then
    TUNING.OWN_HANDS = own_custom_hands
end
if GetModConfigData("skirt") == "custom" then
    TUNING.OWN_SKIRT = own_custom_skirt
end
if GetModConfigData("leg") == "custom" then
    TUNING.OWN_LEGS = own_custom_legs
end
if GetModConfigData("foot") == "custom" then
    TUNING.OWN_FOOTS = own_custom_foots
end
if GetModConfigData("mini-map") == "custom" then
    TUNING.OWN_MAP = own_custom_map
end
if GetModConfigData("own_hp") == 0 then
    TUNING.OWN_HP = own_custom_hp
end
if GetModConfigData("own_hunger") == 0 then
    --TUNING.OWN_HUNGER = own_custom_hunge
end
if GetModConfigData("own_sanity") == 0 then
    TUNING.OWN_SANITY = own_custom_sanity
end
if GetModConfigData("start_item1") == "custom" then
    TUNING.OWN_ITEM1 = own_custom_item1
end
if GetModConfigData("start_item2") == "custom" then
    TUNING.OWN_ITEM2 = own_custom_item2
end
if GetModConfigData("start_item3") == "custom" then
    TUNING.OWN_ITEM3 = own_custom_item3
end
end

if own_custom_only_custom == "true" then
    TUNING.OWN_HEAD = own_custom_head
    TUNING.OWN_HAIR = own_custom_hair
	TUNING.OWN_HAIR2 = own_custom_hair2
	TUNING.OWN_FACE = own_custom_face
	TUNING.OWN_CHEEKS = own_custom_cheers
	TUNING.OWN_TORSO = own_custom_torso
	TUNING.OWN_ARM_UP = own_custom_arm_up
	TUNING.OWN_ARM_LOW = own_custom_arm_low
	TUNING.OWN_HANDS = own_custom_hands
	TUNING.OWN_SKIRT = own_custom_skirt
	TUNING.OWN_LEGS = own_custom_legs
	TUNING.OWN_FOOTS = own_custom_foots
	TUNING.OWN_MAP = own_custom_map
	TUNING.OWN_HP = own_custom_hp
	--TUNING.OWN_HUNGER = own_custom_hunge
	TUNING.OWN_SANITY = own_custom_sanity
	TUNING.OWN_ITEM1 = own_custom_item1
	TUNING.OWN_ITEM2 = own_custom_item2
	TUNING.OWN_ITEM3 = own_custom_item3
end

local UIAnim = require "widgets/uianim"
local Screen = require "widgets/screen"
local Button = require "widgets/button"
local AnimButton = require "widgets/animbutton"
local ImageButton = require "widgets/imagebutton"
local Text = require "widgets/text"
local Image = require "widgets/image"
local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"

local function UpdateMainScreen(self)
	self.own_man = self.left_col:AddChild(UIAnim())
    self.own_man:GetAnimState():SetBank("own_menu")
    self.own_man:GetAnimState():SetBuild("own_menu")
    self.own_man:GetAnimState():PlayAnimation("idle", true)
    self.own_man:SetPosition(-130,-320,0)
	self.own_man:SetScale(0.7, 0.7, 0.7)
	
	self.own_man:GetAnimState():OverrideSymbol("headbase", TUNING.OWN_HEAD, "headbase")
	self.own_man:GetAnimState():OverrideSymbol("headbase_hat", TUNING.OWN_HEAD, "headbase_hat")
	self.own_man:GetAnimState():OverrideSymbol("hair", TUNING.OWN_HAIR2, "hair")
	self.own_man:GetAnimState():OverrideSymbol("hair_hat", TUNING.OWN_HAIR2, "hair_hat")
	self.own_man:GetAnimState():OverrideSymbol("hairpigtails", TUNING.OWN_HAIR, "hairpigtails")
	self.own_man:GetAnimState():OverrideSymbol("face", TUNING.OWN_FACE, "face")
	self.own_man:GetAnimState():OverrideSymbol("cheeks", TUNING.OWN_CHEEKS, "cheeks")
	self.own_man:GetAnimState():OverrideSymbol("torso", TUNING.OWN_TORSO, "torso")
	self.own_man:GetAnimState():OverrideSymbol("torso_pelvis", TUNING.OWN_TORSO_PELVIS, "torso_pelvis")
	self.own_man:GetAnimState():OverrideSymbol("arm_upper", TUNING.OWN_ARM_UP, "arm_upper")
	self.own_man:GetAnimState():OverrideSymbol("arm_lower", TUNING.OWN_ARM_LOW, "arm_lower")
	self.own_man:GetAnimState():OverrideSymbol("hand", TUNING.OWN_HANDS, "hand")
	self.own_man:GetAnimState():OverrideSymbol("skirt", TUNING.OWN_SKIRT, "skirt")
	self.own_man:GetAnimState():OverrideSymbol("leg", TUNING.OWN_LEGS, "leg")
	self.own_man:GetAnimState():OverrideSymbol("foot", TUNING.OWN_FOOTS, "foot")
end

AddClassPostConstruct("screens/mainscreen", UpdateMainScreen)

--GLOBAL.TheInput:AddKeyUpHandler(282, Press_Random)
GLOBAL.TheInput:AddKeyUpHandler(282, Press_Random2)
